ctdb: Remove an unnecessary cast
[vlendec/samba-autobuild/.git] / ctdb / tools / ctdb_diagnostics
index 2cdf3ccdfcf44f74cf8f1300895eb7d8b42efa5f..d16a71c8f30d07170848376b91ea2d9ddda89929 100755 (executable)
@@ -1,18 +1,89 @@
 #!/bin/sh
 # a script to test the basic setup of a CTDB/Samba install 
 # tridge@samba.org September 2007
+# martin@meltin.net August 2010
+
+usage ()
+{
+    cat >&2 <<EOF
+Usage: ctdb_diagnostics [OPTION] ...
+  options:
+    -n <nodes>  Comma separated list of nodes to operate on
+    -c          Ignore comment lines (starting with '#') in file comparisons
+    -w          Ignore whitespace in file comparisons
+    --no-ads    Do not use commands that assume an Active Directory Server
+EOF
+    exit 1
+
+}
+
+nodes=$(ctdb listnodes -X | cut -d'|' -f2)
+bad_nodes=""
+diff_opts=
+no_ads=false
+
+parse_options ()
+{
+    temp=$(getopt -n "ctdb_diagnostics" -o "n:cwh" -l no-ads,help -- "$@")
+
+    # No! Checking the exit code afterwards is actually clearer...
+    # shellcheck disable=SC2181
+    [ $? -eq 0 ] || usage
+
+    eval set -- "$temp"
+
+    while true ; do
+       case "$1" in
+           -n) nodes=$(echo "$2" | sed -e 's@,@ @g') ; shift 2 ;;
+           -c) diff_opts="${diff_opts} -I ^#.*" ; shift ;;
+           -w) diff_opts="${diff_opts} -w" ; shift ;;
+           --no-ads) no_ads=true ; shift ;;
+           --) shift ; break ;;
+           -h|--help|*) usage ;;
+       esac
+    done
+
+    [ $# -ne 0 ] && usage
+}
+
+parse_options "$@"
+
+# Use 5s ssh timeout if EXTRA_SSH_OPTS doesn't set a timeout.
+case "$EXTRA_SSH_OPTS" in
+    *ConnectTimeout=*) : ;;
+    *)
+       export EXTRA_SSH_OPTS="${EXTRA_SSH_OPTS} -o ConnectTimeout=5"
+esac
+
+# Filter nodes.  Remove any nodes we can't contact from $node and add
+# them to $bad_nodes.
+_nodes=""
+for _i in $nodes ; do
+    if onnode "$_i" true >/dev/null 2>&1 ; then
+       _nodes="${_nodes}${_nodes:+ }${_i}"
+    else
+       bad_nodes="${bad_nodes}${bad_nodes:+,}${_i}"
+    fi
+done
+nodes="$_nodes"
+
+nodes_comma=$(echo "$nodes" | sed -e 's@[[:space:]]@,@g')
 
 PATH="$PATH:/sbin:/usr/sbin:/usr/lpp/mmfs/bin"
 
 # list of config files that must exist and that we check are the same 
-# on all nodes
-CONFIG_FILES_MUST="/etc/krb5.conf /etc/hosts /etc/ctdb/nodes /etc/sysconfig/ctdb /etc/resolv.conf /etc/nsswitch.conf /etc/sysctl.conf /etc/samba/smb.conf /etc/fstab /etc/multipath.conf /etc/pam.d/system-auth /etc/sysconfig/nfs /etc/exports /etc/vsftpd/vsftpd.conf"
+# on the nodes
+if [ -d /etc/sysconfig ] ; then
+    CONFIG_FILES_MUST="/etc/krb5.conf /etc/hosts /usr/local/etc/ctdb/nodes /etc/sysconfig/ctdb /etc/resolv.conf /etc/nsswitch.conf /etc/sysctl.conf /etc/samba/smb.conf /etc/fstab /etc/multipath.conf /etc/pam.d/system-auth /etc/sysconfig/nfs /etc/exports /etc/vsftpd/vsftpd.conf"
+else
+    CONFIG_FILES_MUST="/etc/krb5.conf /etc/hosts /usr/local/etc/ctdb/nodes /etc/default/ctdb /etc/resolv.conf /etc/nsswitch.conf /etc/sysctl.conf /etc/samba/smb.conf /etc/fstab /etc/multipath.conf /etc/pam.d/system-auth /etc/default/nfs /etc/exports /etc/vsftpd/vsftpd.conf"
+fi
 
 # list of config files that may exist and should be checked that they
-# are the same on all nodes
-CONFIG_FILES_MAY="/etc/ctdb/public_addresses /etc/ctdb/static-routes"
+# are the same on the nodes
+CONFIG_FILES_MAY="/usr/local/etc/ctdb/public_addresses /usr/local/etc/ctdb/static-routes"
 
-2>&1
+exec 2>&1
 
 cat <<EOF
 --------------------------------------------------------------------
@@ -27,84 +98,126 @@ date
 error() {
     msg="$1"
     echo "ERROR: $msg"
-    NUM_ERRORS=`expr $NUM_ERRORS + 1`
-    echo " ERROR[$NUM_ERRORS]: $msg" >> $ERRORS
+    NUM_ERRORS=$((NUM_ERRORS + 1))
+    echo " ERROR[$NUM_ERRORS]: $msg" >> "$ERRORS"
 }
 
 show_file() {
     fname="$1"
+    _fdetails=$(ls -l "$fname" 2>&1)
     echo "  ================================"
     echo "  File: $fname"
-    echo "  `ls -l $fname 2>&1`"
-    cat "$fname" 2>&1 | sed 's/^/  /'
+    echo "  $_fdetails"
+    sed 's/^/  /' "$fname" 2>&1
     echo "  ================================"
 }
 
 show_all() {
-    echo "running $1 on all nodes"
-    onnode all "hostname; date; $1 2>&1 | sed 's/^/  /'"
+    echo "running $1 on nodes $nodes_comma"
+    onnode "$nodes_comma" "hostname; date; $1 2>&1 | sed 's/^/  /'" 2>&1
+}
+
+show_and_compare_files () {
+
+    fmt="$1" ; shift
+
+    for f ; do
+       _bf=$(basename "$f")
+       first=true
+
+       for n in $nodes ; do
+
+           if $first ; then
+               onnode "$n" [ -r "$f" ] || {
+                   # This function takes a format string
+                   # shellcheck disable=SC2059
+                   msg=$(printf "$fmt" "$f" "$n")
+                   error "$msg"
+                   continue 2;
+               }
+
+               fstf="${tmpdir}/${_bf}.node${n}"
+               onnode "$n" cat "$f" >"$fstf" 2>&1
+
+               _fdetails=$(onnode "$n" ls -l "$f" 2>&1)
+               echo "  ================================"
+               echo "  File (on node $n): $f"
+               echo "  $_fdetails"
+               sed 's/^/  /' "$fstf"
+               echo "  ================================"
+               first=false
+           else
+               echo "Testing for same config file $f on node $n"
+               tmpf="${tmpdir}/${_bf}.node${n}"
+               onnode "$n" cat "$f" >"$tmpf" 2>&1
+               # Intentional multi-word splitting on diff_opts
+               # shellcheck disable=SC2086
+               diff $diff_opts "$fstf" "$tmpf" >/dev/null 2>&1 || {
+                   error "File $f is different on node $n"
+                   diff -u $diff_opts "$fstf" "$tmpf"
+               }
+               rm -f "$tmpf"
+           fi
+       done
+
+       rm -f "$fstf"
+    done
 }
 
-ERRORS="/tmp/diag_err.$$"
-NUM_NODES=`wc -l < /etc/ctdb/nodes`
-MAX_NODE=`expr $NUM_NODES - 1`
+if ! tmpdir=$(mktemp -d) ; then
+    echo "Unable to create a temporary directory"
+    exit 1
+fi
+ERRORS="${tmpdir}/diag_err"
 NUM_ERRORS=0
+
+cat <<EOF
+Diagnosis started on these nodes:
+$nodes_comma
+EOF
+
+if [ -n "$bad_nodes" ] ; then
+    cat <<EOF
+
+NOT RUNNING DIAGNOSTICS on these uncontactable nodes:
+$bad_nodes
+EOF
+
+fi
+
 cat <<EOF
-Diagnosis started on a $NUM_NODES node cluster. The following node list will be used:
+
+For reference, here is the nodes file on the current node...
 EOF
-show_file /etc/ctdb/nodes
 
+show_file /usr/local/etc/ctdb/nodes
 
 cat <<EOF
 --------------------------------------------------------------------
-Comping critical config files on all nodes
+Comping critical config files on nodes $nodes_comma
 EOF
 
-for f in $CONFIG_FILES_MUST; do
- [ -r "$f" ] || {
-    error "$f is missing on this node"
-    continue;
- }
- show_file $f
- for i in `seq 0 $MAX_NODE`; do
-     echo "Testing for same config file $f on node $i"
-     tmpf=/tmp/`basename $f`.node$i
-     onnode $i cat $f > $tmpf 2>&1
-     cmp $f $tmpf 2>&1 || {
-        error "File $f is different on node $i"
-        diff -u $f $tmpf
-     }
-     rm -f $tmpf
- done
-done
+# Intentional multi-word splitting on CONFIG_FILES_MUST
+# shellcheck disable=SC2086
+show_and_compare_files \
+    "%s is missing on node %d" \
+    $CONFIG_FILES_MUST
 
-for f in $CONFIG_FILES_MAY; do
- [ -r "$f" ] || {
-    echo "Optional file $f is not present on local node"
-    continue;
- }
- show_file $f
- for i in `seq 0 $MAX_NODE`; do
-     echo "Testing for same config file $f on node $i"
-     tmpf=/tmp/`basename $f`.node$i
-     onnode $i cat $f > $tmpf 2>&1
-     cmp $f $tmpf 2>&1 || {
-        error "File $f is different on node $i"
-        diff -u $f $tmpf
-     }
-     rm -f $tmpf
- done
-done
+# Intentional multi-word splitting on CONFIG_FILES_MAY
+# shellcheck disable=SC2086
+show_and_compare_files \
+    "Optional file %s is not present on node %d" \
+    $CONFIG_FILES_MAY
 
 cat <<EOF
 --------------------------------------------------------------------
 Checking for clock drift
 EOF
-t=`date +%s`
-for i in `seq 0 $MAX_NODE`; do
-    t2=`onnode $i date +%s`
-    d=`expr $t2 - $t`
-    if [ $d -gt 30 -o $d -lt -30 ]; then
+t=$(date +%s)
+for i in $nodes; do
+    t2=$(onnode "$i" date +%s)
+    d=$((t2 - t))
+    if [ "$d" -gt 30 ] || [ "$d" -lt -30 ]; then
        error "time on node $i differs by $d seconds"
     fi
 done
@@ -115,7 +228,7 @@ Showing software versions
 EOF
 show_all "uname -a"
 [ -x /bin/rpm ] && {
-    show_all "rpm -qa | egrep 'samba|ctdb|gpfs'"
+    show_all "rpm -qa | grep -E 'samba|ctdb|gpfs'"
 }
 [ -x /usr/bin/dpkg-query ] && {
     show_all "/usr/bin/dpkg-query --show 'ctdb'"
@@ -131,17 +244,16 @@ EOF
 show_all "ctdb status; ctdb ip"
 show_all "ctdb statistics"
 show_all "ctdb uptime"
+show_all "ctdb listvars"
+show_all "ctdb getdbmap"
+show_all "ctdb -X getdbmap | awk -F'|' 'NR > 1 {print \$3}' | sort | xargs -n 1 ctdb dbstatistics"
 
 echo "Showing log.ctdb"
-show_all "test -f /var/log/log.ctdb && tail -100 /var/log/log.ctdb"
-
-echo "Showing log.ctdb"
-show_all "test -f /var/log/log.ctdb && tail -100 /var/log/log.ctdb"
+show_all "test -f /usr/local/var/log/log.ctdb && tail -100 /usr/local/var/log/log.ctdb"
 
 show_all "tail -200 /var/log/messages"
-show_all "tail -200 /etc/ctdb/state/vacuum.log"
-show_all "ls -lRs /var/ctdb"
-show_all "ls -lRs /etc/ctdb"
+show_all "ls -lRs /usr/local/var/lib/ctdb"
+show_all "ls -lRs /usr/local/etc/ctdb"
 
 
 cat <<EOF
@@ -161,9 +273,10 @@ show_all "cat /proc/cpuinfo"
 show_all "cat /proc/scsi/scsi"
 show_all "/sbin/ifconfig -a"
 show_all "/sbin/ifconfig -a"
+show_all "cat /proc/net/dev"
 show_all "/sbin/ip addr list"
 show_all "/sbin/route -n"
-show_all "netstat -s"
+show_all "ss -s"
 show_all "free"
 show_all "crontab -l"
 show_all "sysctl -a"
@@ -188,52 +301,32 @@ show_all "/usr/sbin/nfsstat -v"
     done
 }
 
-[ -d /usr/lpp/mmfs ] && {
-cat <<EOF
---------------------------------------------------------------------
-Showing GPFS status and recent log entries
-EOF
- show_all "tail -100 /var/adm/ras/mmfs.log.latest"
- show_all "/usr/lpp/mmfs/bin/mmlsconfig"
- show_all "/usr/lpp/mmfs/bin/mmlsfs all"
- show_all "/usr/lpp/mmfs/bin/mmlsnsd"
- show_all "/usr/lpp/mmfs/bin/mmlsnsd -X"
- show_all "/usr/lpp/mmfs/bin/mmfsadm dump version"
- show_all "/usr/lpp/mmfs/bin/mmfsadm dump waiters"
- show_all "/usr/lpp/mmfs/bin/mmlsmount all"
- show_all "/usr/lpp/mmfs/bin/mmlsquota"
- show_all "/usr/lpp/mmfs/bin/mmlscluster"
- show_all "/usr/lpp/mmfs/bin/mmlsmgr"
- devlist=`mmlsfs all|grep ^File.system.attributes | cut -d/ -f3 | cut -d: -f1`
- for d in $devlist; do
-     show_all "mmdf $d"
-     show_all "mmlsdisk $d"
-     show_all "mmlsfileset $d"
-     show_all "mmlspolicy $d"
-     show_all "mmlssnapshot $d"
- done
- fslist=`mount|grep type.gpfs|awk '{print $1}'`
- for fs in $fslist; do
-     show_all "/usr/lpp/mmfs/bin/mmlssnapshot $fs"
-     show_all "/usr/lpp/mmfs/bin/mmlsdisk $fs"
-     show_all "/usr/lpp/mmfs/bin/mmlsfileset $fs"
- done
-}
-
 cat <<EOF
 --------------------------------------------------------------------
 Showing Samba status
 EOF
 show_all "smbstatus -n -B"
-show_all "net ads testjoin"
+if $no_ads ; then
+    echo
+    echo "Skipping \"net ads testjoin\" as requested"
+    echo
+else
+    show_all "net ads testjoin"
+fi
 show_all "net conf list"
 show_all "lsof -n | grep smbd"
 show_all "lsof -n | grep ctdbd"
 show_all "netstat -tan"
-show_all "net ads info"
+if $no_ads ; then
+    echo
+    echo "Skipping \"net ads info\" as requested"
+    echo
+else
+    show_all "net ads info"
+fi
 show_all "date"
 show_all "smbclient -U% -L 127.0.0.1"
-WORKGROUP=`testparm -s --parameter-name=WORKGROUP 2> /dev/null`
+WORKGROUP=$(testparm -s --parameter-name=WORKGROUP 2> /dev/null)
 show_all id "$WORKGROUP/Administrator"
 show_all "wbinfo -p"
 show_all "wbinfo --online-status"
@@ -242,9 +335,12 @@ show_all "smbd -b"
 date
 echo "Diagnostics finished with $NUM_ERRORS errors"
 
-[ -r $ERRORS ] && {
-    cat $ERRORS
-    rm -f $ERRORS
+[ -r "$ERRORS" ] && {
+    cat "$ERRORS"
+    rm -f "$ERRORS"
 }
+
+rm -rf "$tmpdir"
+
 exit $NUM_ERRORS